<?php

/**
* @copyright	Copyright (C) 2009 - 2015 Ready Bytes Software Labs Pvt. Ltd. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* @package		Payplans
* @subpackage		Menu Access App
* @contact		support+payplans@readybytes.in
*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Payplans Menu Access Plugin
 *
 * @author Puneet
 */
class plgPayplansMenuAccess extends XiPlugin
{
	
	public function onPayplansSystemStart()
	{
		$dir = dirname(__FILE__).DS.'menuaccess'.DS.'app';
		PayplansHelperApp::addAppsPath($dir);
		
		$userId 	= XiFactory::getUser()->id;
        $user    	= PayplansUser::getInstance($userId);
        
		//Nothing to do on Admin-end or when user is super user.
		if(XiFactory::getApplication()->isAdmin() || $user->isAdmin()){
		    return true;
		}

		XiHelperLoader::addAutoLoadFolder(dirname(__FILE__).DS.'menuaccess'.DS.'joomla', '' , 'J');
		class_exists("JMenu", true);
		return true;
		
	}

    public function onAfterRoute()
	{
		$option = JRequest::getVar('option', '');
		$task   = JRequest::getVar('task', '');
		
		//No Restriction on login and logout of a user.
		if($option == "com_users" && !empty($task) && ($task == "user.logout" || $task = "user.login")){
			return true;
		}
		
		$siteApp 	= XiFactory::getApplication();

	 	$userId 	= XiFactory::getUser()->id;
	 	$user		= PayplansUser::getInstance($userId);
        
		//Nothing to do on Admin-end or when user is super user.
       	if($siteApp->isAdmin() || $user->isAdmin()){
        	return true;
        }
		
		$redirected	   = JRequest::getVar('redirected', 0);
		
		//Already Redirected then bypass.
		if($redirected == 1){
			JRequest::setVar('redirected', false);
			return true;
		}
		
		//Load All Apps of type Menu Access
		$menuAccessApp = PayplansHelperApp::getAvailableApps('menuaccess');
		
		//No App Exists then nothing to do.
		if(empty($menuAccessApp)){
			return true;
		}
		
		//parse the request url
		$uri 	= clone JUri::getInstance();
		$router = $siteApp->getRouter();
		$requestedUrl = $router->parse($uri);
		if (!isset($requestedUrl['id']) && $requestedUrl['option'] == 'com_zoo')
		{
			$query  = new XiQuery();
			$query ->select('params')
				->from('#__menu')
				->where('id = '."'".$requestedUrl['Itemid']."'");
			$record = $query->dbLoadQuery()->loadObjectList();
			if(!empty($record)){
				foreach ($record as $key => $value)
				{
				    $params 		= json_decode($value->params, true);
				    $id 		= $params['item_id'];
				    $requestedUrl['id'] = $id;
				}
			}
		}

		if(array_key_exists('Itemid',$requestedUrl)){
			unset($requestedUrl['Itemid']);
		}

		//Need to unset format entity added in case of 'Add suffix to url' is set to yes
		if(isset($requestedUrl['format'])){
			unset($requestedUrl['format']);
		} 
		
		$menu		= $siteApp->getMenu();
		//Get All Restricted Menus
		$appMenu	= array();
		$menuPlans  	= array();
		$userPlans  	= $user->getPlans(PayplansStatus::SUBSCRIPTION_ACTIVE);
		
		foreach($menuAccessApp as $menuAccessAppId=>$app){
			//fetch restrcited menus and process them. 
			$app_menus = $app->getAppParam('allowedMenus');
			$app_menus = is_array($app_menus) ? $app_menus : array($app_menus);

			//Load Menu Item of Joomla
			foreach($app_menus as $menuId){
				$appMenu = $menu->getItem($menuId);
				
			    //Menu might have been deleted
			    if (!$appMenu) {
			        continue;
			    }
			
				if (!strpos($appMenu->link,'&id'))
				{
					$params        = $appMenu->params;
					if ($params->get('item_id')) {
						$appMenu->link = $appMenu->link."&id=".$params->get('item_id');
					}
				}

				$lang="";
				if ($appMenu->language != '*') {
					$getLang = explode('-', $appMenu->language);
					$lang = '&lang='.$getLang[0];
				} else {
					//if in the menu it is set to all,language filter plugin is enabled
					// and user's site is multilangual. Then remove the language parameter.
					if (isset($requestedUrl['lang'])){
							unset($requestedUrl['lang']);
					}
				}
				//Separate Out All Elements form Query String
				$appMenu_Url	= JUri::getInstance($link = "$appMenu->link".$lang)->getQuery(true);

				// If id is set then remove it
				if(isset($appMenu_Url['id']) && !isset($requestedUrl['id'])){
					unset($appMenu_Url['id']);
				}
				
				// Append plans of only those apps, which is having request menu url as restricted
				if($appMenu_Url === $requestedUrl){
					$applyAll  = $app->getParam('applyAll', 0);
					$app_plans = ($applyAll == 1) ? PayplansHelperPlan::getPlans(array('published' => 1), false) : $app->getPlans();
					$menuPlans = array_merge($menuPlans,$app_plans); 
				}
			}
		}

		//Check for the all the plans which are added with applicable menu(restricted menu)
		// and allow user only if he has one of those plan
		if(!empty($menuPlans) && !array_intersect($userPlans, $menuPlans)){

			$app = JFactory::getApplication();

			if (!$app->isAdmin() && !$this->params->get('show404error',false))
			{
				$message = XiText::_('COM_PAYPLANS_APP_MENUACCESS_SUBSCRIPTION_EXPIRATION_MESSAGE');
				$app->enqueueMessage($message, 'error');
				$app->redirect(XiRoute::_('index.php?option=com_payplans&view=plan&task=subscribe'));
			}
			else{
				throw new Exception(XiText::_('COM_PAYPLANS_APP_MENUACCESS_PAGE_NOT_FOUND_MESSAGE'), '404');
				return true;
			}
		}
		
		return true;				
	}
	
	public function onPayplansMenusLoad(&$menus)
	{
        $menuAccessApp = PayplansHelperApp::getAvailableApps('menuaccess');
		if(XiFactory::getApplication()->isAdmin() || empty($menuAccessApp)){
			return true;
		}

		//Step 1:- Select user plan
		$user	= XiFactory::getUser();
		$pUser  = PayplansUser::getInstance($user->id);
		
		// Is user Admin/SuperAdmin
		if($pUser->isAdmin()){
			return true;
		}
		
		//Gets Plan(s) of user
		$userPlans = $pUser->getPlans(PayPlansStatus::SUBSCRIPTION_ACTIVE);
		
		//step 2:- select those menus which we want to display or hide according to app
		$display = $hide = array();
		foreach($menuAccessApp as $menuAccessAppId=>$app)
		{
			$applyAll  = $app->getParam('applyAll', 0);
			$app_menus = $app->getAppParam('allowedMenus');
			$app_menus = (is_array($app_menus)) ? $app_menus : array($app_menus);

			$app_plans = ($applyAll == 1) ? PayplansHelperPlan::getPlans(array('published' => 1), false) : $app->getPlans();
			
			if(array_intersect($userPlans, $app_plans)){
				$display = array_merge($display, $app_menus);
			}else{
				$hide = array_merge($hide, $app_menus);
			}
		}
		
		//step 3:- remove allowed menus from hide list
		$hide = array_diff($hide, $display);	
		
		//step 4:- remove menus which are in hide list 
		// check show menus to user or not
		$plg 		= XiHelperPlugin::getPluginInstance('payplans','menuaccess');
		$showMenu	= $plg->params->get('showOrhide',false);
		foreach ($hide as $hidemenu)
		{
			if(isset($menus[$hidemenu])){
                //App do not allow to show menus to user then unset those Menus  
				if(!$showMenu){
					$menus[$hidemenu]->access = 0;
				}
			}	
		}
	}
}
